Graphics 1024,768,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global lobby        = LoadImage("hotel_lobby.png")
Global first_floor  = LoadImage("hotel_hall_red.png")
Global second_floor = LoadImage("hotel_hall_dblue.png")
Global third_floor  = LoadImage("hotel_hall_green.png")
Global fourth_floor = LoadImage("hotel_hall_orange.png")
Global fifth_floor  = LoadImage("hotel_hall_blue.png")

Global font1 = LoadFont("Arial",50,1,0,0)
Global people_delivered = 0
Global money_made = 0
Global people_in_elevator = 0

Global customer_creation_timer = MilliSecs()

Type elevator
 Field image
 Field current_floor
 Field destination
 Field x,y
 Field speed
 Field people ;how many are currently in the elevator?
 Field moving ;is elevator moving?
End Type 

Type hotel_floor
 Field y
 Field number
End Type 

Type button
 Field number
 Field on
 Field x,y
End Type 

Type customer
 Field x,y
 Field current_floor
 Field destination
 Field happiness
 Field image = LoadImage("customer.png")
 Field happy_timer
End Type 


Global e.elevator = New elevator
 e\image = LoadImage("elevator.png")
  HandleImage e\image,ImageWidth(e\image)/2,ImageHeight(e\image)/2
  MaskImage e\image,255,0,255
 e\current_floor = 1
 e\destination = 0
 e\speed = 0
 e\people = 0
 e\x = 50
 e\y = 495
 e\moving = 0

For i = 1 To 6
 h.hotel_floor = New hotel_floor
  h\number = i
  
  Select(i)
   Case 6
    h\y = 45
   Case 5
    h\y = 135
   Case 4
    h\y = 225
   Case 3
    h\y = 315
   Case 2 
    h\y = 405
   Case 1 
    h\y = 495
  End Select 

 b.button = New button
  b\number = i
  b\on = 0

  Select(i)
   Case 6
    b\x = 933
    b\y = 400
   Case 5
    b\x = 842
    b\y = 400
   Case 4
    b\x = 933
    b\y = 310
   Case 3
    b\x = 842
    b\y = 310
   Case 2
    b\x = 933
    b\y = 220
   Case 1 
    b\x = 842
    b\y = 220
  End Select 
Next 

b.button = New button
 b\number = 0
 b\on = 0
 b\x = 933
 b\y = 490


Repeat : Cls 

 
 Draw_Action()
 DrawImage e\image,e\x,e\y
 Draw_Buttons()
 Show_Stats()


 If e\current_floor < e\destination And e\current_floor <> 0 And e\destination <> 0
  e\y = e\y - 1
 EndIf 

 If e\current_floor > e\destination And e\current_floor <> 0 And e\destination <> 0
  e\y = e\y + 1
 EndIf 

 For h.hotel_floor = Each hotel_floor
  If h\number = e\destination
   If e\y = h\y
    e\moving = 0
    e\current_floor = e\destination
    
    For b.button = Each button 
     b\on = 0
    Next 
   EndIf 
  EndIf 
 Next 

Flip : Until KeyHit(1)

Function Draw_Action() ;Draw the gameplay screen (everything but buttons and score)
 DrawImage fifth_floor,0,0    
 DrawImage fourth_floor,0,90  : ;Line 100,90,751,90 ;5th floor ceiling
 DrawImage third_floor,0,180  : ;Line 100,180,751,180 ;4th floor ceiling
 DrawImage second_floor,0,270 : ;Line 100,270,751,270 ;3rd floor ceiling
 DrawImage first_floor,0,360  : ;Line 100,360,751,360 ;2nd floor ceiling
 DrawImage lobby,0,450        : ;Line 100,450,751,450 ;1st floor ceiling
End Function 


Function Draw_Buttons()
 SetFont font1

 Color 255,255,255 
  Rect 802,50,170,100,0 : Text 887,100,e\current_floor,1,1 ;Floor screen above buttons

 Operate_Buttons()

 For b.button = Each button

  If b\on = 1
   Color 253,253,0
    Oval b\x-40,b\y-40,80,80,1
  EndIf 

  Color 255,255,255
   Oval b\x-40,b\y-40,80,80,0
  
  If b\number <> 0
   Text b\x,b\y,b\number,1,1
  Else 
   Text b\x,b\y,"E",1,1
  EndIf 
 Next   

End Function 


Function Operate_Buttons()
 If MouseHit(1) And e\moving = 0
  For b.button = Each button
   If Distance_Formula(MouseX(),b\x,MouseY(),b\y) <= 40
    b\on = 1
    e\destination = b\number
    e\moving = 1
   EndIf 
  Next 
 EndIf 
End Function 

 
Function Distance_Formula(x_one#,x_two#,y_one#,y_two#)
 Return Sqr( (x_one - x_two)^2 + (y_one - y_two)^2 )
End Function


Function Show_Stats()
 Text 1024/2,570,"People Served: " + people_delivered,1,1
 Text 1024/2,620,"Cash Made: " + money_made,1,1
 Text 1024/2,670,"# of People in Elevator: " + people_in_elevator,1,1
End Function 



 
   